Attribute VB_Name = "mdlMain"
Option Explicit

Public Const REGSEC = "Andres Solutions"
Public Const REGPRG = "GRFW"

Public DisplayErrorMsg As Boolean

'shell execute
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

'ontop
Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

'delete file
Declare Function DeleteFile Lib "kernel32.dll" Alias "DeleteFileA" (ByVal lpFileName As String) As Long

'-- detect OS version
Public Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Public Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
End Type

'openfile
Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (lpofn As OPENFILENAME) As Long
Type OPENFILENAME
    lStructSize As Long
    hWndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustomFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    FLAGS As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type
Public Const OFN_FILEMUSTEXIST = &H1000
Public Const OFN_HIDEREADONLY = &H4
Public Const OFN_PATHMUSTEXIST = &H800
Public Const SW_SHOWNORMAL = 1

Const GENERIC_READ = &H80000000
Const GENERIC_WRITE = &H40000000
Const FILE_SHARE_READ = &H1
Const FILE_SHARE_WRITE = &H2
Const CREATE_ALWAYS = 2
Const CREATE_NEW = 1
Const OPEN_ALWAYS = 4
Const OPEN_EXISTING = 3
Const TRUNCATE_EXISTING = 5
Const FILE_ATTRIBUTE_ARCHIVE = &H20
Const FILE_ATTRIBUTE_HIDDEN = &H2
Const FILE_ATTRIBUTE_NORMAL = &H80
Const FILE_ATTRIBUTE_READONLY = &H1
Const FILE_ATTRIBUTE_SYSTEM = &H4
Const FILE_FLAG_DELETE_ON_CLOSE = &H4000000
Const FILE_FLAG_NO_BUFFERING = &H20000000
Const FILE_FLAG_OVERLAPPED = &H40000000
Const FILE_FLAG_POSIX_SEMANTICS = &H1000000
Const FILE_FLAG_RANDOM_ACCESS = &H10000000
Const FILE_FLAG_SEQUENTIAL_SCAN = &H8000000
Const FILE_FLAG_WRITE_THROUGH = &H80000000

'themes
Public Type INITCOMMONCONTROLSEX_TYPE
    dwSize As Long
    dwICC As Long
End Type
Public Declare Function InitCommonControlsEx Lib "comctl32.dll" (lpInitCtrls As INITCOMMONCONTROLSEX_TYPE) As Long
Public Const ICC_INTERNET_CLASSES = &H800

'-- move form
Declare Sub ReleaseCapture Lib "user32" ()
Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Integer, ByVal lParam As Long) As Long

' Registry value types
Public Enum regValueType
    REG_SZ = 1
    REG_EXPAND_SZ = 2
    REG_BINARY = 3
    REG_DWORD = 4
End Enum

'Predefined Keys
Public Enum regROOT
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_USERS = &H80000003
End Enum

'Errors
Public Enum regError
    ERROR_SUCCESS = 0
    ERROR_BADDB = 1
    ERROR_BADKEY = 2
    ERROR_CANTOPEN = 3
    ERROR_CANTREAD = 4
    ERROR_CANTWRITE = 5
    ERROR_OUTOFMEMORY = 6
    ERROR_INVALID_PARAMETER = 7
    ERROR_ACCESS_DENIED = 8
    ERROR_INVALID_PARAMETERS = 87
    ERROR_NO_MORE_ITEMS = 259
End Enum

Const KEY_ALL_ACCESS As Long = &H3F
Const REG_OPTION_NON_VOLATILE = 0

Private Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Long
    bInheritHandle As Long
End Type

Declare Function RegCreateKeyEx Lib "Advapi32" Alias "RegCreateKeyExA" (ByVal hkey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, lpSecurityAttributes As SECURITY_ATTRIBUTES, phkResult As Long, lpdwDisposition As Long) As Long
Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hkey As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hkey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hkey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long
Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (dest As Any, source As Any, ByVal numBytes As Long)

' Opens a Registry key, or creates it if it doesn't yet exist
' *Needs - Registry root specifier (eg. HKEY_CURRENT_USER, etc) - type regROOT
' *Needs - Variable specifying the name of a subkey that this function opens or creates - type String
' *Returns -            Handle to the new/exisiting key, -1 on Error
' *Return Value Type -  Long
Public Function CreateKey(ByVal ROOT As regROOT, ByVal SubKey As String) As regError
    Dim hNewKey As Long         '-- Handle to the new key
    Dim RetVal As Long          '-- Result of the RegCreateKeyEx function
    Dim tSA As SECURITY_ATTRIBUTES
    RetVal = RegCreateKeyEx(ROOT, SubKey, 0, vbNullString, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, tSA, hNewKey, RetVal)
    If RetVal <> ERROR_SUCCESS Then
        If DisplayErrorMsg Then MsgBox "Unable to open registry key: """ + SubKey + """", vbCritical, "Registry Error"
        CreateKey = -1
    End If
    CreateKey = hNewKey
End Function

' Reads a registry key's Value
' *Needs - Handle to an open key, returned by CreateKey - type Long
' *Needs - Variable containing the name of the value to query - type String
' *Needs - Variable containing the value of the key - type String ByRef
' *Needs - Type of the queried registry key (eg String, DWORD, etc) - type regValueType
' *Returns -            Error value (regERROR types) if no error return is ERROR_SUCCESS
' *Return Value type -  regError
Public Function ReadKeyValue(ByVal hkey As Long, ByVal ValueName As String) As Variant
    Dim RetVal As Long          '-- Result of the RegQueryValueEx function
    Dim valSize As Long
    Dim tType As Long
    Dim regDataString As String
    Dim regDataLong As Long
    
    Dim resBinary() As Byte
    valSize = 1024
    ReDim resBinary(0 To valSize - 1) As Byte

    RetVal = RegQueryValueEx(hkey, ValueName, 0, tType, resBinary(0), valSize)
    If RetVal <> ERROR_SUCCESS Then
        If DisplayErrorMsg Then MsgBox "Unable to read registry value: """ + ValueName + """", vbCritical, "Registry Error"
    End If
    Select Case tType
        Case REG_SZ
            regDataString = Space$(valSize - 1)
            CopyMemory ByVal regDataString, resBinary(0), valSize - 1
            ReadKeyValue = regDataString
        Case REG_DWORD
            CopyMemory regDataLong, resBinary(0), 4
            ReadKeyValue = regDataLong
        Case Else
            RegCloseKey (hkey)
            Err.Raise 1001, , "Unsupported Value Type"
    End Select
End Function

' Sets a registry key's value
' *Needs - Handle to an open key, returned by CreateKey - type Long
' *Needs - Variable containing the name of the value to query - type String
' *Needs - Variable containing the value of the key to be changed - type String / Long
' *Needs - Type of the queried registry key (eg String, DWORD, etc) - type regValueType
' *Returns -            Error value (regERROR types) if no error return is ERROR_SUCCESS
' *Return Value type -  regError
Public Function SetKeyValue(ByVal hkey As Long, ByVal ValueName As String, ByVal regData As Variant, ByVal tType As regValueType) As regError
    Dim RetVal As Long          '-- Result of the RegQueryValueEx function
    Dim strValue As String
    Dim longValue As Long
    
    Select Case tType
        Case REG_SZ
            If VarType(regData) = vbString Then
                strValue = regData
                RetVal = RegSetValueEx(hkey, ValueName, 0, tType, ByVal strValue, Len(strValue))
            Else
                RetVal = ERROR_INVALID_PARAMETER
            End If
        Case REG_DWORD
            If VarType(regData) = vbInteger Or vbLong Then
                longValue = regData
                RetVal = RegSetValueEx(hkey, ValueName, 0, tType, longValue, 4)
            Else
                RetVal = ERROR_INVALID_PARAMETER
            End If
        Case Else
            RegCloseKey (hkey)
            Err.Raise 1001, , "Unsupported Value Type"
    End Select
    
    If RetVal <> ERROR_SUCCESS Then
        If DisplayErrorMsg Then MsgBox "Unable to write registry value: """ + ValueName + """", vbCritical, "Registry Error"
    End If
    SetKeyValue = RetVal
End Function

Public Sub FormDrag(TheForm As Form)
ReleaseCapture
Call SendMessage(TheForm.hwnd, &HA1, 2, 0&)
End Sub

'goto url
Public Sub Goto_URL(sURL As String)
    Dim iret As Long
    iret = ShellExecute(Screen.ActiveForm.hwnd, vbNullString, sURL, vbNullString, "c:\", SW_SHOWNORMAL)
End Sub

Function FileFound(FileName As String) As Boolean
If Dir(FileName) = "" Then FileFound = False Else FileFound = True
End Function

Sub GoToWebsite(MainSite As Boolean)

If MainSite = True Then
    Goto_URL "http://www.divxland.org/ttd/ttdsolutions.htm"
    Else
    Goto_URL "http://users.tt-forums.net/andrex/ttdsolutions.htm"
End If
    
End Sub
